=== debian/changelog ===
likwid (5.4.1+dfsg-1) unstable; urgency=medium

  * New upstream version 5.4.1+dfsg
  * update 10-debianize.patch
  * don't try to chown root during install (closes: #1092412)
  * update package description (closes: #1094416)
  * update symbol version from 5.3 to 5.4
  * update overrides to 5.4
  * build-depend on debhelper-compat = 13
  * bump standards version (no changes)
  * remove debian/compat

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 29 Jan 2025 16:03:24 +0100
