=== debian/control ===
Source: likwid
Maintainer: Christoph Martin <martin@uni-mainz.de>
Section: misc
Priority: optional
Standards-Version: 4.7.0
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 gfortran,
 libhwloc-dev,
 liblua5.3-dev,
 python3,
Homepage: https://github.com/rrze-likwid/likwid
Vcs-Git: https://salsa.debian.org/debian/likwid.git
Vcs-Browser: https://salsa.debian.org/debian/likwid

Package: likwid
Architecture: amd64 i386 x32
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 lua5.3,
 ${misc:Depends},
 ${perl:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 feedgnuplot,
Description: toolsuite for performance oriented programmers
 Likwid is a simple to install and use toolsuite of command line applications
 for performance oriented programmers. It works for Intel and AMD processors
 on the Linux operating system.
 .
 It consists of:
 .
 likwid-topology       - print thread, cache and NUMA topology
 likwid-perfctr        - configure and read out hardware performance counters
                         on Intel, AMD, ARM and POWER processors and Nvidia
                         GPUs
 likwid-powermeter     - read out RAPL Energy information and get info about
                         Turbo mode steps
 likwid-pin            - pin your threaded application (pthread, Intel and gcc
                         OpenMP to dedicated processors)
 likwid-bench          - Micro benchmarking platform for CPU architectures
 likwid-features       - Print and manipulate cpu features like hardware
                         prefetchers (x86 only)
 likwid-genTopoCfg     - Dumps topology information to a file
 likwid-mpirun         - Wrapper to start MPI and Hybrid MPI/OpenMP
                         applications (Supports Intel MPI, OpenMPI, MPICH
                         and SLURM)
 likwid-perfscope      - Frontend to the timeline mode of likwid-perfctr,
                         plots live graphs of performance metrics using gnuplot
 likwid-memsweeper     - Sweep memory of NUMA domains and evict cachelines
                         from the last level cache
 likwid-setFrequencies - Tool to control the CPU and Uncore frequencies
                         (x86 only)
 likwid-sysFeatures    - Tool to system settings like frequencies, powercaps
                         and prefetchers (experimental)
