=== debian/watch ===
version=3
opts=repacksuffix=+dfsg,dversionmangle=s/\+dfsg1\d*$// \
  https://ftp.fau.de/pub/likwid/likwid-(\d[\d.]*)\.tar\.gz debian uupdate
